precision highp float;
#define DMAX 0.5

uniform sampler2D inputImageTexture;
varying vec2 st;

//uniform float vignetteStart;
//uniform float vignetteEnd;
uniform float strength;
uniform float blur;

void main()
{
    vec3 rgb = texture2D(inputImageTexture, st).rgb;
    float d = distance(st, vec2(0.5, 0.5));

    float percent = smoothstep(DMAX * 0.5 + (DMAX * 0.5 - 0.01) * blur, DMAX * 2.0 - (DMAX - 0.01) * blur, d) * abs(strength);

    gl_FragColor = vec4(mix(rgb.x, step(0., strength) * 1.3, percent), mix(rgb.y, step(0., strength) * 1.3, percent), mix(rgb.z, step(0., strength) * 1.3, percent), 1.0);
}