
precision highp float;

varying highp vec2 st;

uniform sampler2D inputImageTexture;

uniform float threshold;

float Lum(vec3 c){
    return 0.299*c.r + 0.587*c.g + 0.114*c.b;
}

void main()
{
    vec4 base = texture2D(inputImageTexture, st);

    float lum = Lum(base.rgb);

    gl_FragColor = mix(vec4(0.0, 0.0, 0.0, 1.0), base, step(threshold, lum));
}
