
precision highp float;

varying highp vec2 st;

uniform sampler2D inputImageTexture1;

uniform sampler2D inputImageTexture2;

uniform float opacity;

float Lum(vec3 c){
    return 0.298839*c.r + 0.586811*c.g + 0.11435*c.b;
}

void main()
{
    vec4 base = texture2D(inputImageTexture1, st);

    vec4 overlay = texture2D(inputImageTexture2, st);

    base = mix(base, base + 2. * overlay - vec4(1.0), Lum(overlay.rgb) * opacity);

//    base.b = mix(base.b, base.b + 2. * overlay.b - 1., overlay.b * opacity);
//    base.g = mix(base.g, base.g + 2. * overlay.g - 1., overlay.g * opacity * 0.5);
//    base.r = mix(base.r, base.r + 2. * overlay.r - 1., overlay.r * opacity * 0.5);
    gl_FragColor = base;
}
