precision highp float;
precision mediump int;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float opacity;

 vec3 blend(vec4 base, vec4 overlay) {
//     return base.rgb + overlay.rgb - base.a * overlay.a;

     vec3 baseRGB = base.rgb / (base.a + step(base.a, 0.0));
     vec3 overlayRGB = overlay.rgb / (overlay.a + step(overlay.a, 0.0));
     return (1.0 - overlay.a) * base.rgb + (1.0 - base.a) * overlay.rgb + base.a * overlay.a * clamp(baseRGB + overlayRGB - 1.0, 0.0, 1.0);
 }

void main()
{
    lowp vec4 base = texture2D(inputImageTexture, textureCoordinate);
    lowp vec4 overlay = texture2D(inputImageTexture2, textureCoordinate2) * opacity;

    gl_FragColor = vec4(blend(base, overlay), base.a + overlay.a - base.a * overlay.a);
}