precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float opacity;

float rgb2gray(vec3 rgb){
    return dot(vec3(0.299, 0.587, 0.114), rgb);
}

void main()
{
    vec4 base = texture2D(inputImageTexture, textureCoordinate);

    float gray = rgb2gray(base.rgb);
    float decay = 1.0 - smoothstep(0.6, 0.9, gray);

    vec4 overlayer = texture2D(inputImageTexture2, textureCoordinate2) * opacity * decay;
    gl_FragColor = overlayer * base + overlayer * (1.0 - base.a) + base * (1.0 - overlayer.a);
}