precision highp float;

varying vec2 st;

uniform sampler2D inputImageTexture1;

uniform sampler2D inputImageTexture2;

uniform float opacity;

uniform float exposure;


void main() {

    vec3 col1 = texture2D(inputImageTexture1, st).rgb;

    vec3 col2 = texture2D(inputImageTexture2, st).rgb;

    col1 += col2 * 1.5; // additive blending
    // tone mapping
    vec3 result = vec3(1.0) - exp(-col1 * exposure);

    result = pow(result, vec3(1. / 2.2));

    gl_FragColor = vec4(result, 1.0);
}