precision highp float;

varying vec2 st;

uniform sampler2D inputImageTexture;

uniform vec2 size;

uniform int radius;

uniform int orientation;

void main() {
    float weight = 0.;
    vec4 color = vec4(0.);
    if(orientation == 0){
        float dy = 1. / size.y;
        for (int i = - radius; i <= radius; i++){
            float w = exp(- pow (float(i), 2.) / (2. * pow(float(radius) / 3.0, 2.)));
            color += texture2D(inputImageTexture, st + vec2(0.0 , dy * float(i))) * w;
            weight += w;
        }
    }else{
        float dx = 1. / size.x;
        for (int i = - radius; i <= radius; i++){
            float w = exp(- pow (float(i), 2.) / (2. * pow(float(radius) / 3.0, 2.)));
            color += texture2D(inputImageTexture, st + vec2(dx * float(i), 0.0)) * w;
            weight += w;
        }
    }
    gl_FragColor =  color / weight;
}