precision highp float;

#define TWO_PI 6.28318530718
varying vec2 st;
uniform sampler2D inputImageTexture;
uniform vec2 size;
uniform float angle;
uniform float radius;
uniform float strength;

void main(){
    vec3 result = vec3(0.);
    float weight = 1.;
    float weights = 0.;
    vec2 loc = vec2(0.);
    for(float i = -radius; i <= radius; i++){
        loc = st + 3. * i * vec2(cos(angle), sin(angle)) / size;
        result += weight * texture2D(inputImageTexture, loc).rgb;
        weights += weight;
    }
    result = result / weights;
    result = mix(texture2D(inputImageTexture, st).rgb, result, strength);
    gl_FragColor = vec4(result, 1.);
}
