precision highp float;
#define ACC 48

varying vec2 st;

uniform sampler2D inputImageTexture;

uniform vec2 size;


float rand(vec2 n) {
    return fract(sin(dot(n, vec2(12.9898, 4.1414))) * 43758.5453);
}

float rand2(float x){
    return mod((mod(x, 13.0) + 1.0) * (mod(x, 123.0) + 1.0), 0.01) + 0.0025;
}

float noise(vec2 p){
    vec2 ip = floor(p);
    vec2 u = fract(p);
    u = u*u*(3.0-2.0*u);

    float res = mix(
    mix(rand(ip), rand(ip+vec2(1.0, 0.0)), u.x),
    mix(rand(ip+vec2(0.0, 1.0)), rand(ip+vec2(1.0, 1.0)), u.x), u.y);
    return res*res;
}

//uniform float intensity;
void main() {

    vec2 uv = st;
    for(int i = 1; i < ACC; i++){
        vec2 random_center = vec2(rand(vec2(76.0, 57.0 + float(i) * 3.2)) * 2.0 - 1.0,
        rand(vec2(23.0 + float(i) * 8.3, 57.0)) * 24.0 - 12.0);
        float l = length(st - random_center);
//        float n = 0.02 * sin(l * (64.0 + float(i) * 2.0) + float(i)) * rand(vec2(float(i) + 8.0, float(i) + 12.0)) * exp(-l);
//        float n = 0.2 * sin(l * (64.0 + float(i) * 2.0) + float(i)) * rand2(float(i) * 13.14 + float(i));
        float n = 0.2 * exp(sin(l * 65.841 + float(i) * 2.0 + float(i))) * rand2(float(i) * 13.14 + float(i));
//        float n = 0.02 * sin(l * (64.0 + float(i) * 2.0) + float(i)) * exp(-l);
//        float n = 0.001 * sin(l * 124.0 + float(i)) * (1.0 + st.y) * rand(vec2(float(i) + 8.0, float(i) + 12.0));
        uv += (uv - random_center) * vec2(n);
    }

    vec4 result = texture2D(inputImageTexture, vec2(uv.x, 1.0 - uv.y));

    vec4 color = texture2D(inputImageTexture, st);
//
    gl_FragColor = mix(result, color, smoothstep(0.4, 0.6, st.y));

//    gl_FragColor = result;
}