precision highp float;

varying vec2 st;

uniform sampler2D inputImageTexture;

uniform vec2 size;
//uniform float intensity;
uniform float iTime;

const float PI = 3.14159265359;

float genWave(float len)
{
    float wave = sin(7.0 * PI * len - iTime*5.0);
    float wavePow = 1.0 - pow(abs(wave*1.1), 0.8);
    wave = wavePow * wave;
    return wave;
}

void main( )
{
    vec2 pos2 = vec2(st - vec2(0.5, 0.25));

    vec2 pos2n = normalize(pos2);

    float len = length(pos2);

    float dist = max(1. - len, 0.);

    float wave = genWave(len);

    vec2 uv2 = pos2n * (wave - 0.1) / (1.0 + 16.0 * len);

    vec2 offset = uv2 * dist + 0.015 * abs(st.y - 0.25) * vec2(sin((st.x * st.y + st.y) * 40. + 2842.), cos((st.x * st.x + st.y) * 26. + 2842.));

    vec2 uv = st + offset;

    vec3 grad = normalize(vec3(offset, 0.1));
    //
    vec3 light = normalize(vec3(.5, .5, .6));
    //
    float diffuse = dot(grad, light);
    //
    float spec = pow(max(0., -reflect(light, grad).z), 8.);

    gl_FragColor = vec4(texture2D(inputImageTexture, uv)) * max(diffuse, 0.0) + spec;;
}