precision highp float;

varying vec2 st;

uniform sampler2D inputImageTexture;

uniform float threshold;

vec3 kLuminance = vec3(0.2125, 0.7154, 0.0721);

float rgb2gray(vec3 rgb){
    return dot(rgb, kLuminance);
}


void main() {

    vec4 col = texture2D(inputImageTexture, st);

    col = mix(vec4(0.0), col, step(threshold, rgb2gray(col.rgb)));

    gl_FragColor = col;
}